#include <thread>
#include <mutex>
#include <iostream>
#include <map>
#include <string>
#include "UniSocket.hpp"
using namespace std;
    
mutex mtx;
map<int, UniSocket> clientPool;
    
void sendAllOthers(string msg, int id) {
	cout<<"client "<<id<<" sends to "<<endl;
	map<int, UniSocket>::iterator it;
	mtx.lock();
	for(it = clientPool.begin(); it != clientPool.end(); ++it) {
		if(it->first == id) continue;
		cout<<"  client "<< it->first <<endl;
		(it->second).send(
			"client " + \
			to_string(id) + \
			" (" + (it->second).getIp() + "): " + \
			msg
		);
	}
	mtx.unlock();
}
    
// jeder client sein eigener Thread!
void sockHandle(UniSocket usock, int myId) {
	cout<<"Hello client "<<myId<<endl;
	mtx.lock();
	clientPool[myId] = usock;
	mtx.unlock();
	string msg;
	while(1) {
		msg = usock.recv();
		if(msg == "[close]") break;
		sendAllOthers(msg, myId);
	}
	cout<<"Bye client "<<myId<<endl;
	usock.send("[bye]");
	usock.close();
	mtx.lock();
	clientPool.erase(myId);
	mtx.unlock();
}
    
int main(int argc, char * argv[]) {
	int idCounter = 0;
	if (argc < 2) {
		cout<<"usage: "<<argv[0]<<" <port>"<<endl;
		return 1;
	}
    
	try {
		UniServerSocket svr(atoi(argv[1]), 5, "[ENDE]");
		while (1) {
			idCounter++;
			thread t(sockHandle, svr.accept(), idCounter);
			t.detach();
		}
	} catch(UniSocketException e) {
		cout << e._msg << endl;
	}
	return 0;
}
